#!/usr/bin/perl -w
# script to retrieve genomic sequences of inverted repeats identified by run_einverted.pl
# usage: fold_inverted_repeats.pl repeatfile genome outfile

use lib "/home2/mjonesrh/miRcheck"; # edit to directory that contains miRcheck.pm 
use miRcheck;

$file = $ARGV[0]; 
$genome = $ARGV[1]; #Fasta file
$outfile = $ARGV[2];

$FLANKING_NT = 10; # number of flanking nt added to each side of inverted repeat

$rseqs = hash_FASTA($genome);
%seqs = %{$rseqs};

open(F,$file);
open(TMP,">$outfile\_tmp");

@lines = <F>;

foreach $l (@lines){
    if ($l =~ /(\S+) (\d+) \d+ (\d+)/){
	$chr = $1;
	$x = $2 - $FLANKING_NT;
	$y = $3 + $FLANKING_NT;
    }
    $seq = get_subseq($seqs{$chr},$x,$y);  # gets + strand
    $seq = uc($seq);
    $seq =~ tr/MRWSYKVHDBX/NNNNNNNNNNN/;
    print TMP ">$chr\_$x\_$y\n$seq\n";
    
    $seq = get_subseq($seqs{$chr},$y,$x); # gets - strand
    $seq = uc($seq);
    $seq =~ tr/MRWSYKVHDBX/NNNNNNNNNNN/;
    print TMP ">$chr\_$y\_$x\n$seq\n";

}
@lines = ();
close(TMP);
system("/home2/mjonesrh/_miRNA_search/_scripts/RNAfold <$outfile\_tmp > $outfile");
