#!/usr/bin/perl -w
# Retrieves genomic regions containing matches identifed by run_patscan.pl, with specified number of flanking nucleotides on each side.

# usage:  retrieve_genomic_regions.pl window_size sample_miRNA_matches  sample_genome.fa sample_miRNA_matches_genomic

$WIN = $ARGV[0]; # number of flanking nucleotides to add to each side of putative miRNA  
$hitfile =$ARGV[1]; # list of sequences and genomic coorinates
$genome = $ARGV[2]; #Fasta file of genomic sequence
$outfile = $ARGV [3]; #name of outputfile

if (not($outfile)){print "usage: retrieve_genomic_regions.pl window_size sample_miRNA_matches  sample_genome.fa sample_miRNA_matches_genomic\n";exit;}

use lib "/home2/mjonesrh/miRcheck"; # edit to directory containing miRcheck.pm
use miRcheck;

$rseqs = hash_FASTA($genome);
%seqs = %{$rseqs};

open(O,">$outfile");
open(F,$hitfile);
while(<F>){
    if (/query:(\S+)\s+qseq:(\S+) hit:(\S+) sense:(\S+) beg:(\d+) end:(\d+) hseq:(\S+)/){
        $line = $_;
        chomp($line);
        $id = $1;
        $chr = $3;
        $sense = $4;
        $x = $5;
        $y = $6;
        $hseq = $7;
        $chr =~ s/>//g;
        if ($sense eq 'sense'){
	    $beg = max(1,$x - $WIN);
	    $end = min(length($seqs{$chr}),$y + $WIN);
            $s = '+';
            $POS = min($WIN,$x-1);
        }
	else{
            $beg = min(length($seqs{$chr}),$x + $WIN);
            $end = max(1,$y - $WIN);
            $s = '-';
            $POS = min($WIN,(length($seqs{$chr}) - $x)-1);
        }

        #retrieve flanking sequence 
	$name = "$id\_$chr\_$x$s";
        $subseq = get_subseq($seqs{$chr},$beg,$end);
	$start = $POS ;
	$stop = $start + abs($x - $y);
	print O ">$name\t$chr\t$beg\t$end\t$hseq\t$start\t$stop\n$subseq\n";
    }
}

